=== debian/changelog ===
rnp (0.14.0-6) unstable; urgency=medium

  * Produce more useful diagnostics for s2k iteration test
  * use patches from upstream where possible
  * update build-deps to match adopted upstream changes
  * avoid using the network for gtest and ruby in upstream-preferred form
  * work around unclear upstream guidance for building with googletest
  * use upstream manpages
  * fix spelling errors in upstream manpages

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 01 Mar 2021 20:43:22 -0500

rnp (0.14.0-5) unstable; urgency=medium

  * move C API docs to librnp-0-dev package
  * Initial autopkgtest, building and running example .c files
  * Use versioned Build-Depends

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sun, 28 Feb 2021 23:57:35 -0500

rnp (0.14.0-4) unstable; urgency=medium

  * new source-only release to unstable
  * d/clean: clean up Testing/Temporary/ directory

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sun, 28 Feb 2021 09:32:03 -0500

rnp (0.14.0-3) unstable; urgency=medium

  * clean export
  * clean up patch metadata
  * re-enable parallel builds, even in /tmp
  * avoid building the test suite when nocheck is present

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 12 Feb 2021 00:50:49 -0500

rnp (0.14.0-2) unstable; urgency=medium

  * include manpages
  * spelling fixes
  * clean up librnp.3 manpage

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 11 Feb 2021 16:37:41 -0500

rnp (0.14.0-1) unstable; urgency=low

  * Initial debian packaging (Closes: #945537).

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 11 Feb 2021 07:26:51 -0500
