## rnp 0.15.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -36,7 +36,7 @@
 
 # determine version
 if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/cmake/version.cmake")
-  file(DOWNLOAD https://raw.githubusercontent.com/riboseinc/cmake-versioning/c78a0be/version.cmake
+  file(DOWNLOAD https://raw.githubusercontent.com/rnpgp/cmake-versioning/main/version.cmake
     "${CMAKE_CURRENT_SOURCE_DIR}/cmake/version.cmake")
 endif()
 include(cmake/version.cmake)
@@ -53,6 +53,14 @@
 option(ENABLE_COVERAGE "Enable code coverage testing.")
 option(ENABLE_SANITIZERS "Enable ASan and other sanitizers.")
 option(ENABLE_FUZZERS "Enable fuzz targets.")
+option(DOWNLOAD_GTEST "Download Googletest" On)
+option(DOWNLOAD_RUBYRNP "Download ruby-rnp and run related tests." On)
+
+# tri-state options
+set(TRISTATE_VALUES On Off Auto)
+
+set(ENABLE_DOC Auto CACHE STRING "Enable building documentation.")
+set_property(CACHE ENABLE_DOC PROPERTY STRINGS ${TRISTATE_VALUES})
 
 # so we can use our bundled finders
 set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/Modules")
@@ -134,6 +142,11 @@
   link_libraries(-fsanitize=leak,address,undefined)
 endif()
 
+# adoc for man generation
+if (ENABLE_DOC)
+  include(AdocMan)
+endif()
+
 # everything else is in subdirs
 add_subdirectory(src/examples)
 if (ENABLE_FUZZERS)
@@ -147,6 +160,17 @@
 
 # build tests, if desired
 if (BUILD_TESTING)
+  # Googletest source path
+  if (NOT GTEST_SOURCES)
+    set(GTEST_SOURCES "" CACHE STRING
+    "Path to the Googletest sources in case of download or linking to the precompiled library is disabled."
+    FORCE
+    )
+  else()
+    # Canonicalize path to the Googletest sources.
+    get_filename_component(GTEST_SOURCES_FULL ${GTEST_SOURCES} REALPATH)
+    set(GTEST_SOURCES ${GTEST_SOURCES_FULL})
+  endif()
   add_subdirectory(src/tests)
 endif()
