=== debian/changelog ===
rnp (0.15.2-6build1) jammy; urgency=medium

  * No-change rebuild against libbotan-2-19

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 07 Apr 2022 16:14:30 +0000

rnp (0.15.2-6) unstable; urgency=medium

  * fix S2K tuning
  * refresh patch
  * Use a variant of upstream proposal for filtering exported symbols

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 03 Nov 2021 13:58:40 -0400

rnp (0.15.2-5) unstable; urgency=medium

  * add an explicit version-script to limit symbol exposure
  * make s2k_iteration_tuning test even sloppier on s390x

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 03 Nov 2021 11:09:37 -0400

rnp (0.15.2-4) unstable; urgency=medium

  * streamline AEAD tests for armel and armhf
  * loosen up s2k tuning test for s390x

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 29 Oct 2021 17:08:51 -0400

rnp (0.15.2-3) unstable; urgency=medium

  * Try to ignore accidentally-exported C++ symbols

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 29 Oct 2021 10:03:53 -0400

rnp (0.15.2-2) unstable; urgency=medium

  * Pull version information from debian/changelog (avoid git during build)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 28 Oct 2021 18:29:44 -0400

rnp (0.15.2-1) unstable; urgency=medium

  * new upstream release
  * standards-version: bump to 4.6.0 (no changes needed)
  * drop patch merged upstream
  * silence pedantic lintian warning about test vectors
  * update symbols with rnp_key_get_default_key

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 27 Oct 2021 18:21:28 -0400

rnp (0.15.1-1) unstable; urgency=medium

  * new upstream release
  * support nodoc build profile
  * update symbols

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 03 Jun 2021 21:53:15 -0400

rnp (0.15.0-1) unstable; urgency=medium

  * new upstream release
  * drop unused patches
  * switch from pandoc to asciidoc for manpage generation
  * move to simpler library package names -- librnp-dev and librnp0
  * point upstream to the local copy of googletest
  * augment symbols for 0.15.0

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 08 Apr 2021 12:18:09 -0400
