=== debian/control ===
--- 
+++ 
@@ -1,8 +1,10 @@
 Source: rnp
 Section: utils
 Priority: optional
-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
 Build-Depends:
+ asciidoctor <!nodoc>,
  cmake (>= 3.14),
  debhelper-compat (= 13),
  gnupg <!nocheck>,
@@ -10,12 +12,11 @@
  libbotan-2-dev (>= 2.14.0),
  libbz2-dev,
  libjson-c-dev (>= 0.11),
- pandoc,
  pkg-config,
  python3 <!nocheck>,
  python3-distutils <!nocheck>,
  zlib1g-dev,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Git: https://salsa.debian.org/debian/rnp.git
 Vcs-Browser: https://salsa.debian.org/debian/rnp
 Homepage: https://www.rnpgp.com/software/rnp/
@@ -27,7 +28,7 @@
 Pre-Depends:
  ${misc:Pre-Depends},
 Depends:
- librnp-0-0 (= ${binary:Version}),
+ librnp0 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Description: Cross-platform OpenPGP (RFC4880) tools (command-line tool)
@@ -36,7 +37,7 @@
  .
  This package contains the command-line tool, rnp.
 
-Package: librnp-0-0
+Package: librnp0
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -51,11 +52,13 @@
  .
  This package contains the shared library, librnp.
 
-Package: librnp-0-dev
+Package: librnp-dev
 Section: libdevel
 Architecture: any
+Replaces: librnp-0-dev (<< 0.15.0)
+Breaks: librnp-0-dev (<< 0.15.0)
 Depends:
- librnp-0-0 (= ${binary:Version}),
+ librnp0 (= ${binary:Version}),
  ${misc:Depends},
 Description: Cross-platform OpenPGP (RFC4880) tools (development files)
  RNP is a set of cross-platform tools implementing OpenPGP (RFC 4880) and
